<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEngineloadRPMItemsPerDriver ArrayType
 * @subpackage Arrays
 */
class ArrayOfEngineloadRPMItemsPerDriver extends AbstractStructArrayBase
{
    /**
     * The EngineloadRPMItemsPerDriver
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EngineloadRPMItemsPerDriver[]
     */
    public $EngineloadRPMItemsPerDriver;
    /**
     * Constructor method for ArrayOfEngineloadRPMItemsPerDriver
     * @uses ArrayOfEngineloadRPMItemsPerDriver::setEngineloadRPMItemsPerDriver()
     * @param \StructType\EngineloadRPMItemsPerDriver[] $engineloadRPMItemsPerDriver
     */
    public function __construct(array $engineloadRPMItemsPerDriver = array())
    {
        $this
            ->setEngineloadRPMItemsPerDriver($engineloadRPMItemsPerDriver);
    }
    /**
     * Get EngineloadRPMItemsPerDriver value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EngineloadRPMItemsPerDriver[]|null
     */
    public function getEngineloadRPMItemsPerDriver()
    {
        return isset($this->EngineloadRPMItemsPerDriver) ? $this->EngineloadRPMItemsPerDriver : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEngineloadRPMItemsPerDriver method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEngineloadRPMItemsPerDriver method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEngineloadRPMItemsPerDriverForArrayConstraintsFromSetEngineloadRPMItemsPerDriver(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEngineloadRPMItemsPerDriverEngineloadRPMItemsPerDriverItem) {
            // validation for constraint: itemType
            if (!$arrayOfEngineloadRPMItemsPerDriverEngineloadRPMItemsPerDriverItem instanceof \StructType\EngineloadRPMItemsPerDriver) {
                $invalidValues[] = is_object($arrayOfEngineloadRPMItemsPerDriverEngineloadRPMItemsPerDriverItem) ? get_class($arrayOfEngineloadRPMItemsPerDriverEngineloadRPMItemsPerDriverItem) : sprintf('%s(%s)', gettype($arrayOfEngineloadRPMItemsPerDriverEngineloadRPMItemsPerDriverItem), var_export($arrayOfEngineloadRPMItemsPerDriverEngineloadRPMItemsPerDriverItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EngineloadRPMItemsPerDriver property can only contain items of type \StructType\EngineloadRPMItemsPerDriver, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EngineloadRPMItemsPerDriver value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EngineloadRPMItemsPerDriver[] $engineloadRPMItemsPerDriver
     * @return \ArrayType\ArrayOfEngineloadRPMItemsPerDriver
     */
    public function setEngineloadRPMItemsPerDriver(array $engineloadRPMItemsPerDriver = array())
    {
        // validation for constraint: array
        if ('' !== ($engineloadRPMItemsPerDriverArrayErrorMessage = self::validateEngineloadRPMItemsPerDriverForArrayConstraintsFromSetEngineloadRPMItemsPerDriver($engineloadRPMItemsPerDriver))) {
            throw new \InvalidArgumentException($engineloadRPMItemsPerDriverArrayErrorMessage, __LINE__);
        }
        if (is_null($engineloadRPMItemsPerDriver) || (is_array($engineloadRPMItemsPerDriver) && empty($engineloadRPMItemsPerDriver))) {
            unset($this->EngineloadRPMItemsPerDriver);
        } else {
            $this->EngineloadRPMItemsPerDriver = $engineloadRPMItemsPerDriver;
        }
        return $this;
    }
    /**
     * Add item to EngineloadRPMItemsPerDriver value
     * @throws \InvalidArgumentException
     * @param \StructType\EngineloadRPMItemsPerDriver $item
     * @return \ArrayType\ArrayOfEngineloadRPMItemsPerDriver
     */
    public function addToEngineloadRPMItemsPerDriver(\StructType\EngineloadRPMItemsPerDriver $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EngineloadRPMItemsPerDriver) {
            throw new \InvalidArgumentException(sprintf('The EngineloadRPMItemsPerDriver property can only contain items of type \StructType\EngineloadRPMItemsPerDriver, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EngineloadRPMItemsPerDriver[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EngineloadRPMItemsPerDriver|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EngineloadRPMItemsPerDriver|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EngineloadRPMItemsPerDriver|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EngineloadRPMItemsPerDriver|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EngineloadRPMItemsPerDriver|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EngineloadRPMItemsPerDriver
     */
    public function getAttributeName()
    {
        return 'EngineloadRPMItemsPerDriver';
    }
}
